#include "projet.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

extern GtkWidget *gl_window;

GtkWidget*
create_diamsquare_window (void)
{
  GtkWidget *dsq_window;
  GtkWidget *dsqw_vbox1;
  GtkWidget *dsqw_paramlbl;
  GtkWidget *dsqw_hseparator1;
  GtkWidget *dsqw_table1;
  GtkObject *dsqw_hsb_adj;
  GtkWidget *dsqw_hsb;
  GtkWidget *dsqw_label2;
  GtkWidget *dsqw_label6;
  GtkObject *dsqw_factsb_adj;
  GtkWidget *dsqw_factsb;
  GtkWidget *dsqw_hseparator2;
  GtkWidget *dsqw_hbuttonbox1;
  GtkWidget *dsqw_okb;
  
  GtkWidget *dsqw_wrapbox;

  dsq_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (dsq_window), 3);
  gtk_window_set_transient_for(GTK_WINDOW (dsq_window),GTK_WINDOW (gl_window));
  gtk_window_set_title (GTK_WINDOW (dsq_window), _("Diamond - Square"));

  dsqw_vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (dsqw_vbox1);
  gtk_container_add (GTK_CONTAINER (dsq_window), dsqw_vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (dsqw_vbox1), 2);

  dsqw_paramlbl = gtk_label_new (_("Parametres"));
  gtk_widget_show (dsqw_paramlbl);
  gtk_box_pack_start (GTK_BOX (dsqw_vbox1), dsqw_paramlbl, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (dsqw_paramlbl), GTK_JUSTIFY_LEFT);

  dsqw_hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (dsqw_hseparator1);
  gtk_box_pack_start (GTK_BOX (dsqw_vbox1), dsqw_hseparator1, TRUE, TRUE, 0);

  dsqw_table1 = gtk_table_new (6, 2, FALSE);
  gtk_widget_show (dsqw_table1);
  gtk_box_pack_start (GTK_BOX (dsqw_vbox1), dsqw_table1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (dsqw_table1), 10);
  gtk_table_set_row_spacings (GTK_TABLE (dsqw_table1), 3);
  gtk_table_set_col_spacings (GTK_TABLE (dsqw_table1), 12);

  dsqw_label2 = gtk_label_new (_("Perturbation du terrain"));
  gtk_widget_show (dsqw_label2);
  gtk_table_attach (GTK_TABLE (dsqw_table1), dsqw_label2, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (dsqw_label2), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (dsqw_label2), 0, 0.5);
  
  dsqw_hsb_adj = gtk_adjustment_new (0.920, 0, 1, 0.001, 0.5, 0.5);
  dsqw_hsb = gtk_spin_button_new (GTK_ADJUSTMENT (dsqw_hsb_adj), 0.1, 3);
  gtk_widget_show (dsqw_hsb);
  gtk_table_attach (GTK_TABLE (dsqw_table1), dsqw_hsb, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (dsqw_hsb), TRUE);

  dsqw_label6 = gtk_label_new (_("Facteur d'altitude"));
  gtk_widget_show (dsqw_label6);
  gtk_table_attach (GTK_TABLE (dsqw_table1), dsqw_label6, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (dsqw_label6), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (dsqw_label6), 0, 0.5);

  dsqw_factsb_adj = gtk_adjustment_new (100, 1, 500, 1, 10, 10);
  dsqw_factsb = gtk_spin_button_new (GTK_ADJUSTMENT (dsqw_factsb_adj), 1, 0);
  gtk_widget_show (dsqw_factsb);
  gtk_table_attach (GTK_TABLE (dsqw_table1), dsqw_factsb, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
                    
  dsqw_wrapbox = gtk_check_button_new_with_label (_("repetable a l'infini"));
  gtk_widget_show (dsqw_wrapbox);
  gtk_table_attach (GTK_TABLE (dsqw_table1), dsqw_wrapbox, 0, 1, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);                

  dsqw_hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (dsqw_hseparator2);
  gtk_box_pack_start (GTK_BOX (dsqw_vbox1), dsqw_hseparator2, TRUE, TRUE, 0);

  dsqw_hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (dsqw_hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (dsqw_vbox1), dsqw_hbuttonbox1, TRUE, TRUE, 0);

  dsqw_okb = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (dsqw_okb);
  gtk_container_add (GTK_CONTAINER (dsqw_hbuttonbox1), dsqw_okb);
  GTK_WIDGET_SET_FLAGS (dsqw_okb, GTK_CAN_DEFAULT);

          
  g_signal_connect ((gpointer) dsqw_okb, "clicked",
                    G_CALLBACK (on_diamsqw_okb_clicked),
                    G_OBJECT (dsq_window));
                    
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dsq_window, dsq_window, "dsq_window");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_vbox1, "dsqw_vbox1");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_paramlbl, "dsqw_paramlbl");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_hseparator1, "dsqw_hseparator1");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_table1, "dsqw_table1");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_hsb, "dsqw_hsb");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_label2, "dsqw_label2");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_label6, "dsqw_label6");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_factsb, "dsqw_factsb");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_hseparator2, "dsqw_hseparator2");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_hbuttonbox1, "dsqw_hbuttonbox1");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_okb, "dsqw_okb");
  GLADE_HOOKUP_OBJECT (dsq_window, dsqw_wrapbox, "dsqw_wrapbox");

  gtk_widget_grab_focus (dsqw_okb);
  gtk_widget_grab_default (dsqw_okb);
  return dsq_window;
}
