#include "projet.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

extern GtkWidget *gl_window;

GtkWidget*
create_fault_window (void)
{
  GtkWidget *fault_window;
  GtkWidget *faultw_vbox1;
  GtkWidget *faultw_paramlbl;
  GtkWidget *faultw_hseparator1;
  GtkWidget *faultw_table1;
  GtkObject *faultw_numitersb_adj;
  GtkWidget *faultw_numitersb;
  GtkWidget *faultw_label2;
  GtkWidget *faultw_label6;
  GtkObject *faultw_dhsb_adj;
  GtkWidget *faultw_dhsb;
  GtkWidget *faultw_hseparator2;
  GtkWidget *faultw_hbuttonbox1;
  GtkWidget *faultw_okb;

  fault_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (fault_window), 3);
  gtk_window_set_transient_for(GTK_WINDOW (fault_window),GTK_WINDOW (gl_window));
  gtk_window_set_title (GTK_WINDOW (fault_window), _("Fault formation"));

  faultw_vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (faultw_vbox1);
  gtk_container_add (GTK_CONTAINER (fault_window), faultw_vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (faultw_vbox1), 2);

  faultw_paramlbl = gtk_label_new (_("Parametres"));
  gtk_widget_show (faultw_paramlbl);
  gtk_box_pack_start (GTK_BOX (faultw_vbox1), faultw_paramlbl, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (faultw_paramlbl), GTK_JUSTIFY_LEFT);

  faultw_hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (faultw_hseparator1);
  gtk_box_pack_start (GTK_BOX (faultw_vbox1), faultw_hseparator1, TRUE, TRUE, 0);

  faultw_table1 = gtk_table_new (5, 2, FALSE);
  gtk_widget_show (faultw_table1);
  gtk_box_pack_start (GTK_BOX (faultw_vbox1), faultw_table1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (faultw_table1), 10);
  gtk_table_set_row_spacings (GTK_TABLE (faultw_table1), 3);
  gtk_table_set_col_spacings (GTK_TABLE (faultw_table1), 12);

  faultw_label2 = gtk_label_new (_("Nombre d'iterations"));
  gtk_widget_show (faultw_label2);
  gtk_table_attach (GTK_TABLE (faultw_table1), faultw_label2, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (faultw_label2), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (faultw_label2), 0, 0.5);
  
  faultw_numitersb_adj = gtk_adjustment_new (32, 1, 500, 1, 10, 10);
  faultw_numitersb = gtk_spin_button_new (GTK_ADJUSTMENT (faultw_numitersb_adj), 1, 0);
  gtk_widget_show (faultw_numitersb);
  gtk_table_attach (GTK_TABLE (faultw_table1), faultw_numitersb, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (faultw_numitersb), TRUE);

  faultw_label6 = gtk_label_new (_("dh"));
  gtk_widget_show (faultw_label6);
  gtk_table_attach (GTK_TABLE (faultw_table1), faultw_label6, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (faultw_label6), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (faultw_label6), 0, 0.5);

  faultw_dhsb_adj = gtk_adjustment_new (6.0, 1.0, 32.0, 0.1, 1, 1);
  faultw_dhsb = gtk_spin_button_new (GTK_ADJUSTMENT (faultw_dhsb_adj), 0.3, 2);
  gtk_widget_show (faultw_dhsb);
  gtk_table_attach (GTK_TABLE (faultw_table1), faultw_dhsb, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  faultw_hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (faultw_hseparator2);
  gtk_box_pack_start (GTK_BOX (faultw_vbox1), faultw_hseparator2, TRUE, TRUE, 0);

  faultw_hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (faultw_hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (faultw_vbox1), faultw_hbuttonbox1, TRUE, TRUE, 0);

  faultw_okb = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (faultw_okb);
  gtk_container_add (GTK_CONTAINER (faultw_hbuttonbox1), faultw_okb);
  GTK_WIDGET_SET_FLAGS (faultw_okb, GTK_CAN_DEFAULT);

          
  g_signal_connect ((gpointer) faultw_okb, "clicked",
                    G_CALLBACK (on_faultw_okb_clicked),
                    G_OBJECT (fault_window));
                    
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (fault_window, fault_window, "fault_window");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_vbox1, "faultw_vbox1");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_paramlbl, "faultw_paramlbl");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_hseparator1, "faultw_hseparator1");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_table1, "faultw_table1");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_numitersb, "faultw_numitersb");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_label2, "faultw_label2");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_label6, "faultw_label6");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_dhsb, "faultw_dhsb");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_hseparator2, "faultw_hseparator2");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_hbuttonbox1, "faultw_hbuttonbox1");
  GLADE_HOOKUP_OBJECT (fault_window, faultw_okb, "faultw_okb");

  gtk_widget_grab_focus (faultw_okb);
  gtk_widget_grab_default (faultw_okb);
  return fault_window;
}
