#include "projet.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

extern GtkWidget *gl_window;

GtkWidget*
create_hp_window (void)
{
  GtkWidget *hp_window;
  GtkWidget *hpw_vbox1;
  GtkWidget *hpw_paramlbl;
  GtkWidget *hpw_hseparator1;
  GtkWidget *hpw_table1;
  GtkObject *hpw_numitersb_adj;
  GtkWidget *hpw_numitersb;
  GtkWidget *hpw_label2;
  GtkWidget *hpw_lbl3;
  GtkWidget *hpw_label4;
  GtkObject *hpw_rayminsb_adj;
  GtkWidget *hpw_rayminsb;
  GtkObject *hpw_raymaxsb_adj;
  GtkWidget *hpw_raymaxsb;
  GtkWidget *hpw_label5;
  GtkObject *hpw_exposb_adj;
  GtkWidget *hpw_exposb;
  GtkWidget *hpw_label6;
  GtkObject *hpw_factsb_adj;
  GtkWidget *hpw_factsb;
  GtkWidget *hpw_hseparator2;
  GtkWidget *hpw_hbuttonbox1;
  GtkWidget *hpw_okb;
  
  GtkWidget *hpw_spheresbox;
  GtkWidget *hpw_cratersbox;

  hp_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (hp_window), 3);
  gtk_window_set_transient_for(GTK_WINDOW (hp_window),GTK_WINDOW (gl_window));
  gtk_window_set_title (GTK_WINDOW (hp_window), _("Hyperboloides"));

  hpw_vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (hpw_vbox1);
  gtk_container_add (GTK_CONTAINER (hp_window), hpw_vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hpw_vbox1), 2);

  hpw_paramlbl = gtk_label_new (_("Parametres"));
  gtk_widget_show (hpw_paramlbl);
  gtk_box_pack_start (GTK_BOX (hpw_vbox1), hpw_paramlbl, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (hpw_paramlbl), GTK_JUSTIFY_LEFT);

  hpw_hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hpw_hseparator1);
  gtk_box_pack_start (GTK_BOX (hpw_vbox1), hpw_hseparator1, TRUE, TRUE, 0);

  hpw_table1 = gtk_table_new (6, 2, FALSE);
  gtk_widget_show (hpw_table1);
  gtk_box_pack_start (GTK_BOX (hpw_vbox1), hpw_table1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hpw_table1), 10);
  gtk_table_set_row_spacings (GTK_TABLE (hpw_table1), 3);
  gtk_table_set_col_spacings (GTK_TABLE (hpw_table1), 12);

  hpw_numitersb_adj = gtk_adjustment_new (50, 1, 1000, 1, 10, 10);
  hpw_numitersb = gtk_spin_button_new (GTK_ADJUSTMENT (hpw_numitersb_adj), 1, 0);
  gtk_widget_show (hpw_numitersb);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_numitersb, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (hpw_numitersb), TRUE);

  hpw_label2 = gtk_label_new (_("Nombre d'iterations"));
  gtk_widget_show (hpw_label2);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_label2, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (hpw_label2), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (hpw_label2), 0, 0.5);

  hpw_lbl3 = gtk_label_new (_("Rayon minimum"));
  gtk_widget_show (hpw_lbl3);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_lbl3, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (hpw_lbl3), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (hpw_lbl3), 0, 0.5);

  hpw_label4 = gtk_label_new (_("Rayon maximum"));
  gtk_widget_show (hpw_label4);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_label4, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (hpw_label4), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (hpw_label4), 0, 0.5);

  hpw_rayminsb_adj = gtk_adjustment_new (10, 0, 100, 1, 10, 10);
  hpw_rayminsb = gtk_spin_button_new (GTK_ADJUSTMENT (hpw_rayminsb_adj), 1, 0);
  gtk_widget_show (hpw_rayminsb);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_rayminsb, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  hpw_raymaxsb_adj = gtk_adjustment_new (30, 0, 500, 1, 10, 10);
  hpw_raymaxsb = gtk_spin_button_new (GTK_ADJUSTMENT (hpw_raymaxsb_adj), 1, 0);
  gtk_widget_show (hpw_raymaxsb);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_raymaxsb, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (hpw_raymaxsb), TRUE);

  hpw_label5 = gtk_label_new (_("Exposant"));
  gtk_widget_show (hpw_label5);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_label5, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (hpw_label5), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (hpw_label5), 0, 0.5);

  hpw_exposb_adj = gtk_adjustment_new (0.333, 0, 1, 0.001, 0.5, 0.5);
  hpw_exposb = gtk_spin_button_new (GTK_ADJUSTMENT (hpw_exposb_adj), 0.1, 3);
  gtk_widget_show (hpw_exposb);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_exposb, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (hpw_exposb), TRUE);

  hpw_label6 = gtk_label_new (_("Facteur d'altitude"));
  gtk_widget_show (hpw_label6);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_label6, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (hpw_label6), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (hpw_label6), 0, 0.5);

  hpw_factsb_adj = gtk_adjustment_new (50, 1, 500, 1, 10, 10);
  hpw_factsb = gtk_spin_button_new (GTK_ADJUSTMENT (hpw_factsb_adj), 1, 0);
  gtk_widget_show (hpw_factsb);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_factsb, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  hpw_cratersbox = gtk_check_button_new_with_label (_("Volcans"));
  gtk_widget_show (hpw_cratersbox);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_cratersbox, 0, 1, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
                    
  hpw_spheresbox = gtk_check_button_new_with_label (_("Mammelons"));
  gtk_widget_show (hpw_spheresbox);
  gtk_table_attach (GTK_TABLE (hpw_table1), hpw_spheresbox, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);                   

  hpw_hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (hpw_hseparator2);
  gtk_box_pack_start (GTK_BOX (hpw_vbox1), hpw_hseparator2, TRUE, TRUE, 0);

  hpw_hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hpw_hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (hpw_vbox1), hpw_hbuttonbox1, TRUE, TRUE, 0);

  hpw_okb = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (hpw_okb);
  gtk_container_add (GTK_CONTAINER (hpw_hbuttonbox1), hpw_okb);
  GTK_WIDGET_SET_FLAGS (hpw_okb, GTK_CAN_DEFAULT);

#if 0
  g_signal_connect ((gpointer) hpw_numitersb, "value_changed",
                    G_CALLBACK (on_hpw_numitersb_value_changed),
                    NULL);
  g_signal_connect ((gpointer) hpw_rayminsb, "value_changed",
                    G_CALLBACK (on_hpw_rayminsb_value_changed),
                    NULL);
  g_signal_connect ((gpointer) hpw_raymaxsb, "value_changed",
                    G_CALLBACK (on_hpw_raymaxsb_value_changed),
                    NULL);
  g_signal_connect ((gpointer) hpw_exposb, "value_changed",
                    G_CALLBACK (on_hpw_exposb_value_changed),
                    NULL);
  g_signal_connect ((gpointer) hpw_factsb, "value_changed",
                    G_CALLBACK (on_hpw_factsb_value_changed),
                    NULL);
#endif                   
  g_signal_connect ((gpointer) hpw_okb, "clicked",
                    G_CALLBACK (on_hpw_okb_clicked),
                    G_OBJECT (hp_window));
                    
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (hp_window, hp_window, "hp_window");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_vbox1, "hpw_vbox1");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_paramlbl, "hpw_paramlbl");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_hseparator1, "hpw_hseparator1");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_table1, "hpw_table1");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_numitersb, "hpw_numitersb");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_label2, "hpw_label2");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_lbl3, "hpw_lbl3");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_label4, "hpw_label4");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_rayminsb, "hpw_rayminsb");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_raymaxsb, "hpw_raymaxsb");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_label5, "hpw_label5");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_exposb, "hpw_exposb");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_label6, "hpw_label6");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_factsb, "hpw_factsb");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_hseparator2, "hpw_hseparator2");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_hbuttonbox1, "hpw_hbuttonbox1");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_okb, "hpw_okb");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_cratersbox, "hpw_cratersbox");
  GLADE_HOOKUP_OBJECT (hp_window, hpw_spheresbox, "hpw_spheresbox");

  gtk_widget_grab_focus (hpw_okb);
  gtk_widget_grab_default (hpw_okb);
  return hp_window;
}
