/* Fichier; main.c
 * contient la fonction main du programme
 */

#include "projet.h"

#ifndef DONT_USE_GTK
GtkWidget *gl_window;
#endif

TER_terrain_t *terrain;

void
ui_dependant_setup(int *argc, char **argv[])
{
#ifndef DONT_USE_GTK
 #ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
 #endif /* ENABLE_NLS */
  gtk_set_locale ();
  gtk_init (argc, argv);
  gtk_gl_init (argc, argv);
  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");
  
  gl_window = create_gl_window ();
  gtk_widget_show(gl_window); 
#endif /* not defined DONT_USE_GTK */
  
#ifdef USE_GLUT  
  glutInit(argc, *argv);
  set_up_glut ();  
#endif /* USE_GLUT */
  
#ifdef USE_SDL  
  set_up_sdl ();    
#endif /* USE_SDL */
}

void
ui_dependent_mainloop()
{
#ifndef DONT_USE_GTK
  gtk_main ();
#endif

#ifdef USE_GLUT    
  glutMainLoop();
#endif
  
#ifdef USE_SDL    
  sdl_main_loop();
#endif
}

/* ======================================================
 * main
 * =====================================================
 */
int main (int argc, char *argv[])
{ 
  if (TER_create_new_terrain(&terrain) == 0) {
    fprintf(stderr,"not enough memory to create terrain\n");
    exit(1);
  }   
  cam_init();
  
  ui_dependant_setup(&argc,&argv);
  ui_dependent_mainloop();
  return 0;
}
