#ifndef __ALGOS_H__
#define __ALGOS_H__

#define ALGO_HYPERB_CRATERS 1
#define ALGO_HYPERB_SPHERES 2

/* differents types de terrains que l'on peut gnrer */
enum
{
  TERR_FLAT,        /* terrain plat  z=0, pour les tests */ 
  TERR_MIDDISP,     /* midpoint displacement */
  TERR_DIAM,        /* diamond square */
  TERR_SPHERE,      /* spheres superposees */
  TERR_HYPERB,      /* hyperboloides */
  TERR_FAULT,       /* formation de failles */
  TERR_PARTICLE,    /* particle deposition */
};

typedef struct TER_param_hyperb_t
{
  double power;
  float factor;
  int num_iter;
  int radius_max;
  int radius_min;
  int epsilon;
  
} TER_param_hyperb_t;

typedef struct TER_param_diamsquare_t
{
  float h; 
  float factor;
  int wrap;
  
} TER_param_diamsquare_t;

typedef struct TER_param_middisp_t
{
  float h; 
  float factor;
  int rmax_init;
  
} TER_param_middisp_t;

typedef struct TER_param_particle_t
{
  int num_iter;
  int num_islands;
  float dh0;
  
} TER_param_particle_t;

typedef struct TER_param_fault_t
{
  int num_iter;
  float dh0;
  
} TER_param_fault_t;

void TER_gen_terrain_middisp(TER_terrain_t *terrain);
void TER_gen_terrain_diamond(TER_terrain_t *terrain);
void TER_gen_terrain_sphere(TER_terrain_t *terrain);
void TER_gen_terrain_hyperbole(TER_terrain_t *terrain);
void TER_gen_terrain_fault (TER_terrain_t * terrain);
void TER_gen_terrain_particle (TER_terrain_t * terrain);

#endif
