#ifndef __FILTERS_H__
#define __FILTERS_H__

/* diffrents filtres applicables */
enum
{ 
  TERR_FILTER_NOTHING,
  TERR_FILTER_FIR,
  TERR_FILTER_PUISS,
  TERR_FILTER_MULT,
  TERR_FILTER_CRAT,
  
  TERR_NUM_FILTERS
};

/* color schemes */
enum
{
  TERR_COLOR_SUMMER,
  TERR_COLOR_MARS,
  TERR_COLOR_VENUS,
  TERR_COLOR_OCEAN,
  
  TERR_NUM_COLORS
};

/* valeurs minimales et maximales */
#define TERR_FILTER_NOTHING_MIN 0
#define TERR_FILTER_NOTHING_MAX 0

#define TERR_FILTER_FIR_MIN 0.0
#define TERR_FILTER_FIR_MAX 1.0

#define TERR_FILTER_PUISS_MIN 0.1f
#define TERR_FILTER_PUISS_MAX 1.0f

#define TERR_FILTER_RIV_MIN 3
#define TERR_FILTER_RIV_MAX 50

#define TERR_FILTER_MULT_MIN 0.1f
#define TERR_FILTER_MULT_MAX 5.0f

#define TERR_FILTER_CRAT_MIN 1
#define TERR_FILTER_CRAT_MAX 100

void TER_FIL_FIR (TER_terrain_t * terrain, float k);
void TER_FIL_normalize (TER_terrain_t * terrain);
void TER_FIL_denormalize (TER_terrain_t * terrain);
void TER_FIL_power (TER_terrain_t * terrain, float p);
void TER_FIL_multiply (TER_terrain_t * terrain, float m);
void TER_FIL_river (TER_terrain_t * terrain, int L);
void TER_FIL_craters (TER_terrain_t * terrain, float density);
void TER_FIL_allpositive (TER_terrain_t * terrain);
void TER_FIL_translate_down (TER_terrain_t * terrain);

#endif
